# jenkins-cmake
## Spuštění kontejneru
Ke spuštění je třeba mít nainstalovaný Docker. Kontejner lze snadno spustit pomocí `docker run --name jenkins-smarttester -u root -d -p 8080:8080 -v jenkins-data:/var/jenkins_home -v /var/run/docker.sock:/var/run/docker.sock markovda/jenkins-smarttester:latest`.

Vytvořit volume, do kterého se uloží data z `/var/jenkins_home` je žádoucí, aby se zachovala persistentní data při více spuštěních.

Při dalších spuštěních pak lze spouštět již pomocí `docker start jenkins-smarttester`.

## Vytvoření projektu
Pro vytvoření nového projektu je třeba otevřít `localhost:8080` v prohlížeči. Zde běží webová aplikace Jenkins. Nejdříve je třeba se přihlásit pomocí jednorázového admin hesla. Toto heslo je uloženo ve složce `/var/jenkins_home/secrets/`. Přesná cesta je uvedena ve webovém rozhraní. Pak stačí pouze postupovat podle pokynů, vytvořit admin účet a Jenkins je funkční.

V menu Jenkinse je třeba vytvořit nový projekt. Typ projektu je pouze ten nejzákladnější. Chceme pouze spouštět naše vlastní skripty. V nastavení projektu je třeba nastavit spuštění sestavovacího skriptu v části **Build**. Sestavovací skript je třeba spustit pomocí: `bash -x /var/jenkins_home/install.sh master`. Tento skript pouze stahne a sestaví projekt SmartCGMS.

Pro jeho otestování je třeba přidat další krok pomocí tlačítka `Add build step` a výběru `Execute shell`. Zde je třeba spustit skript pro spuštění testů pomocí: `bash -x /var/jenskins_home/run-tests.sh`. Skript stahne nejnovější release nástroje SmartTester, pokud je třeba a starší smaže. Zkopíruje zkompilované binární soubory SmartCGMS, potřebné pro spuštění testů, ke spustitelnému souboru SmartTester a spustí všechny jednotkové testy. Momentálně jsou navíc spouštěny regresní testy scénářů 1 - 3. Spouštěné testy lze upravovat v souboru `run-tests.sh`.

Soubory `install.sh` a `CMakeLists.txt` jsou modifikované verze souborů z repozitáře `SmartCGMS/Tools`. Byly modyfikovány tak, by vyhovovaly automatickému a neinteraktivnímu spuštění sestavení a testů z projektu Jenkins.

V tomto stavu bude projekt sestaven a otestován. Pokud vše doběhne, bude build nastaven jako úspěšný, přestože některý z testů může selhat. Proto je třeba nainstalovat plugin `Text finder`, který umí podle regulárního výrazu najít sekvenci znaků. Podle toho umí nastavit stav buildu. Tuto funkci je třeba zprovoznit kliknutím na tlačítko `Add post-build action` a výběrem `Search files or console log for the regular expression(s)`. Zde zadat regulární výraz ("ERROR!") a zaškrtnout možnost `Also search the console output`. Pak lze nastavit stav, do kterého se projekt nastaví při nalezení nebo nenalezení shody.

